package de.ozgcloud.eingang.fim;

import static org.assertj.core.api.Assertions.*;

import java.util.Collections;
import java.util.Map;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;

class FimDataUtilTest {

	@DisplayName("Get value as key")
	@Nested
	class TestGetValueAsKey {

		private final String fieldKey = "fieldKey";

		private final Map<String, Object> valueDataMap = Collections.singletonMap("valueDataKey", "valueDataValue");
		private final Map<String, Object> valueMap = Collections.singletonMap(FimDataUtil.VALUE_KEY, valueDataMap);
		private final Map<String, Object> fieldMap = Collections.singletonMap(fieldKey, valueMap);

		@Test
		void shouldReturNullOnNullMap() {
			var map = FimDataUtil.getValueMapByKey(null, fieldKey);

			assertThat(map).isNull();
		}

		@Test
		void shouldReturnNullOnNullKeyValue() {
			var map = FimDataUtil.getValueMapByKey(fieldMap, null);

			assertThat(map).isNull();
		}

		@Test
		void shouldReturnValueMapEntry() {
			var map = FimDataUtil.getValueMapByKey(fieldMap, fieldKey);

			assertThat(map).isEqualTo(valueDataMap);
		}
	}
}